package LMS.frontend;

import com.sun.java.swing.*;

import java.awt.Panel;
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Font;
import java.awt.event.*;
import java.awt.Checkbox;
import java.awt.Button;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.util.*;
import java.net.*;
import java.io.*;

//import EDU.syr.npac.frontend.connector3; (replaced by a local copy)
//import webflow.appletsocket.*; (replace by a local copy)

import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import webflow.backend.*;


public class casc2dPanel extends JPanel implements ItemListener, 
ActionListener     {
 

  lmsFrame frame;
  private SMreply _smreply;
  private SMreply _connect;
  private SMreply runnit;
  String hostName, mname, moduleName; 
  String ClientID;
  int portNumber;
  String smURL;
  ClientSocket socket; 
  private String message1;


  int port;
  DataOutputStream dos;
  DataInputStream dis;
  boolean connected;
  boolean completed;

  String remoteHost="local host";
  int cmode=0;

  public casc2dPanel(lmsFrame frame)    {

  this.frame=frame;
  hostName = frame.hostName;
  portNumber  = frame.portNumber;
  ClientID = frame.ClientID;
  smURL = frame.SM_URL;

System.err.println("smURL="+smURL);

    this.setLayout(new BorderLayout());

    //setBorder(BorderFactory.createTitledBorder("my frame"));

    
 // -------------- title panel ------------------NORTH----------------------  

   JPanel TitlePanel = new JPanel();
   
   //TitlePanel.setForeground(Color.red);
   String LMStitle = new String("CASC2D Interface");
   
   JLabel l1= new   JLabel(LMStitle,  JLabel.CENTER);
   l1.setFont(new Font("Serif",Font.BOLD,14));
   TitlePanel.add(l1); 
   this.add(TitlePanel,BorderLayout.NORTH); 

// --------------- center panel ---------------- CENTER ---------------------


   JPanel CenterPanel = new JPanel();
   CenterPanel.setLayout(new BorderLayout());


   JPanel HostsPanelBorder = new JPanel();
   HostsPanelBorder.setBorder(BorderFactory.createTitledBorder("select host"));

   JPanel HostsPanel = new JPanel();
   JComboBox cBox = new JComboBox();
   cBox.addItem("local host");
   cBox.addItem("dagger.npac.syr.edu");
   cBox.addItemListener(this);
   
   HostsPanel.add(cBox);
   HostsPanelBorder.add(HostsPanel);
   CenterPanel.add(HostsPanelBorder,BorderLayout.WEST);

   JPanel Casc2dModeBorder = new JPanel();
   Casc2dModeBorder.setBorder(BorderFactory.createTitledBorder("select mode"));

  
   JPanel Casc2dMode = new JPanel();

   Casc2dMode.setLayout(new GridLayout(3,1));
   ButtonGroup group = new ButtonGroup();

   JRadioButton button1 = new JRadioButton("stand alone", true);
   button1.addActionListener(this);
   group.add(button1);
   Casc2dMode.add(button1);

   JRadioButton button2 = new JRadioButton("as input for EDYS");
   button2.addActionListener(this);
   group.add(button2);
   Casc2dMode.add(button2);

   JRadioButton button3 = new JRadioButton("enhanced with EDYS");
   button3.addActionListener(this);
   group.add(button3);
   Casc2dMode.add(button3);

   Casc2dModeBorder.add(Casc2dMode);
   CenterPanel.add(Casc2dModeBorder,BorderLayout.CENTER);

   this.add(CenterPanel,BorderLayout.CENTER);            

// ------------ button panel ----------------- SOUTH ---------------------

   JPanel ButtonPanel = new JPanel();
   JButton startButton = new JButton("send data & run CASC2D");
   startButton.addActionListener(this);
   ButtonPanel.add(startButton);
   this.add(ButtonPanel, BorderLayout.SOUTH);
}


public void actionPerformed(ActionEvent e) { 
    String action = e.getActionCommand();
    if(action.startsWith("stand")) {
      System.err.println("run cusc2d, and bring output back");
      cmode=0;
    }
    if(action.startsWith("as input")) {
      System.err.println("run casc2d till end, import data and launch EDYS");
      cmode=1;
    }
    if(action.startsWith("enhanced")) {
      System.err.println("run casc2d, every iteration import data and launch EDYS");
      cmode=2;
    }
    if(action.startsWith("send")) {
      System.err.println("run this stuff");
      runThisStuff();
    }

}

public void itemStateChanged(ItemEvent e) {
   String action =(String)e.getItem();
   int state = e.getStateChange();
   remoteHost=action; 
 }


  public void runThisStuff() {
   System.err.println("submitting CASC2D on "+remoteHost+" in mode "+cmode);
   if(remoteHost.startsWith("local")) {
     moduleName="rCASC2D";
   }
   else {
     int idx=remoteHost.indexOf(".");
     mname=remoteHost.substring(0,idx);
     moduleName="rCASC2D_"+mname;

     System.err.println("Send the data to the remote host now");

     requestTwoModules("SendFile","ReceiveFile_"+mname);
     SMreply runnit = runModules();  
     new connector3(this,hostName); //should talk to the local module only!
     message1="start";
     while(!message1.equals("done")) {
       message1=socket.receive();
       System.err.println("received message :"+message1);
     } 
     destroyAll();   
   }
   System.err.println("module "+moduleName+" requested");

   if(cmode == 0) {
      if(remoteHost.startsWith("local")) {

        System.err.println("starting "+moduleName+" in cmode=0 locally");
        _smreply=requestInit("LMS.backend."+moduleName,hostName);
        if(_smreply != null) {
           System.err.println("received reply from requestInit"); 
        }
        else {
           System.err.println("SOMETHING WENT WRONG !!!!!!!!!!!!!!");
        }
      }
      else {
        System.err.println("starting "+moduleName+" in cmode=0 remotely");
        /* we need a module to receive messages */
        requestTwoModules("Messenger",moduleName); 
      }
     } 

      if(cmode==1) { 
      System.err.println("request init of EDYS");
      System.err.println("starting "+moduleName+" in cmode=0");
        /* now EDYS works as a messenger */
      requestTwoModules(moduleName,"runEDYS"); 
      }

      if(cmode==2) {
      System.err.println("also connect edys output with casc2d input");   
      System.err.println("request init of EDYS");
      System.err.println("starting "+moduleName+" in cmode=0");
        /* now EDYS works as a messenger */
      requestTwoModulesTW(moduleName,"runEDYS"); 
      }

      runnit = runModules();
      new connector3(this,hostName); //should talk to the local module only!
      message1="start";
      while(!message1.equals("done")) {
        message1=socket.receive();
        System.err.println("received message :"+message1);
      } 
      destroyAll();   

    if(!remoteHost.startsWith("local")) {
      /* do not forget to bring the data back!" */ 
     System.err.println("Send the data to the remote host now");

     requestTwoModules("ReceiveFile","SendFile_"+mname);
     SMreply runnit = runModules();  
     new connector3(this,hostName); //should talk to the local module only!
     message1="start";
     while(!message1.equals("done")) {
       message1=socket.receive();
       System.err.println("received message :"+message1);
     } 
     destroyAll();   
    }
  }


  // adopted from WebEeditor

  /**
  * <ol>
  *  <li> Open an Url connection to the SessionManager Object
  *  <li> Tell her your ClientId, new_module request and the name of the module.
  *  <li> Wait its response.
  *  <li> If the first word of first line is OK, this means that 
  *       she got the message and everything is ok. Then read the
  *       port number from the second line to read the result of the
  *       operation.
  * </ol>
  *
  */

  SMreply requestFromServer(String request) {

    SMreply reply = null;
    int current_portNumber = -1;

    if(request==null) return null;

    try
    {
      System.err.println("start requestFromServer");
      //Added by Erol for chache problem
      Date dt = new Date ();
      String tmp = Long.toString(dt.getTime());
      request = request+"&time="+tmp;
      System.err.println("request: "+request);
           
      URL myReq = new URL(request);
      
      try
      {
        DataInputStream dis = new DataInputStream( myReq.openStream() );
        
        String status = dis.readLine();
        StringTokenizer STstatus = new StringTokenizer(status);
        
   System.err.println(" I read status :"+status);

        if( STstatus.countTokens() > 0 &&  
            STstatus.nextElement().equals("OK")  )
        {
          String SportNumber = dis.readLine();
          System.err.println(" I read SportNumber:"+SportNumber);
          
          current_portNumber = Integer.parseInt(SportNumber); 

        } else return reply;

      } catch ( IOException e)
        {
           System.err.println("IOException is raised!");
           e.printStackTrace();
           return reply;
        }

    } catch ( MalformedURLException mue)
      {
        System.err.println(" MalformedURLException is raised!");
        mue.printStackTrace();
        return reply;
      } 
 
    /** If port number is invalid exit */
    if( current_portNumber < 1 ) return reply;

    System.err.println("port number seems to be OK");

    Socket Csocket = null;
    DataInputStream  Cdin  = null;
    DataOutputStream Cdout = null;

    try
    {
      Csocket = new Socket(hostName, current_portNumber );

      Cdin = new DataInputStream( Csocket.getInputStream() );

      Cdout = new DataOutputStream( Csocket.getOutputStream() );

    } catch( UnknownHostException e)
      {
         System.err.println("UnknownHostException" + e +" raised!");
         e.printStackTrace(); 
         return reply;
      }
      catch( IOException e)
      {
         System.err.println("IOException (2)" + e + " raised!");
         e.printStackTrace(); 
         return reply;
      }
       
    System.err.println("create empty reply");   
    reply = new SMreply();
    System.err.println("created empty reply");   

    try
    {
      reply.fromStream(Cdin);
      System.err.println("got reply?"); 
      System.err.println("reply? "+reply.getStatus()+" x");

      if(reply.getStatus() == SMreply.ERROR) 
       	System.err.println( reply.getDescription());

    } catch( NullPointerException e)
      {
         System.err.println("NullPointerException vo requestInit" + e);
         e.printStackTrace();
         return null;
      }

    System.err.println("ready to return from requestFromServer");
    return reply;

  }// end of requestFromServer()

  /**
  * Initialize the module
  */
  public SMreply 
  requestInit(String moduleClassName, String moduleHost)
  //  requestInit(ModuleTreeItem m)
  { 
     String myreq = new String(smURL+"?cmd=new_module&ClientID="+
                               ClientID+"&name="+moduleClassName);

     System.err.println("req(InitModule):"+ myreq);

/*
     ntotal++;
     if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");}
     int lastdot = moduleClassName.lastIndexOf(".")+1;
     String mname = moduleClassName.substring(lastdot);
     System.out.println("---> HASH of "+mname);
     Integer r1 = (Integer)FEclasses.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         am.addNewModule(ntotal,r2,mname,moduleHost);
     }
     else {
        am.addNewModule(ntotal,0,mname,moduleHost);
     }

     System.out.println("End of requestInit ");
 */

     return requestFromServer(myreq); 

  }// end of requestInit()


  /**
  */
  public SMreply
  connect(ID from, ID to, ID fromModule, ID toModule )
  {
    String req = new String(smURL+"?cmd=connect&ClientID="+ClientID);
    req += "&fromStr="+from.getString();
    req += "&fromVal="+from.getInt();
    req += "&toStr="+to.getString();
    req += "&toVal="+to.getInt();
    req += "&mIDfromStr="+fromModule.getString();
    req += "&mIDfromVal="+fromModule.getInt();
    req += "&mIDtoStr="+toModule.getString();
    req += "&mIDtoVal="+toModule.getInt();

    return requestFromServer( req );

  }// end of connect()

  /**
  * Runs all the modules in the current session
  */
  public SMreply
  runModules()
  {
     String req = new String(smURL+"?cmd=run_modules&ClientID="+ClientID);
     System.err.println("runRequest="+req);
     return requestFromServer(req);

  }// end of run()

  /**
  * public version of SMreply destroy that is void (TH)
  */

  public void destroyAll() {
  _smreply = destroy();
  }    

  /**
  * Destroys all the modules in the current session
  */
  public SMreply
  destroy()
  {
    //    am.clean();
    //    ntotal=0;
    

     String req = new String(smURL+"?cmd=destroy_modules&ClientID="+ClientID);

     SMreply rett= requestFromServer(req);

     if( rett == null ) 
         rett = new SMreply(SMreply.ERROR,"Unkown");

     return rett ;

  }// end of destroy()

  public void setValue(String s) {
  System.out.println("setValue: "+s); 
  if(socket != null) {
        socket.send(s);
  }
  else {
        System.err.println("setValue failed!!!! - no socket available");
  }
  } 

  public void ConnectIt(String host, String msg) {
       System.out.println("ConnectIt to "+host);
       // first ask PortServer for the Port
       // you may wait for it till the module registers it

       int ntry=0;
       port = 0;
       while(port==0 & ntry<25) { 

       ntry++;
       // send request GET
       System.out.println("send request GET ("+ntry+")");

    try {
      Socket PSsocket = new Socket(host,5500);
      dos= new DataOutputStream(PSsocket.getOutputStream());
      dis= new DataInputStream(PSsocket.getInputStream());
      } catch(IOException e) {System.out.println(e.toString());}
    
      // String msg = "GET";  now it is an input argument
        int sl = msg.length();
        byte[] buf =new byte[sl];
        msg.getBytes(0,sl,buf,0); 
        System.out.println("Trying to send... "+msg);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e+" while sending GET");}

	  // get replay

        String replay = "";
        try{
           int ls=dis.readInt();
           byte buf1[] = new byte[ls];
           dis.read(buf1,0,ls);
           replay = new String(buf1,0,ls);
           System.out.println("I have received from PortServer: "+replay);
        } catch(IOException e){
          System.out.println(e+" while getting replay");
	  if(socket!=null) {socket.stop();}       //  stop();
        }
        Integer iport = new Integer(replay);
        port = iport.intValue();
      } // end of while look
 

       if(port != 0) {
         System.out.println("Try to connect to port :"+port+" at "+hostName);
         socket = new ClientSocket(this,hostName,port);
         connected=true;
       }
       else {
         System.out.println("Connection failed!");
       }
  } 

  public void requestTwoModules(String moduleName1, String moduleName2) {
  
 
 // here I am assuming that moduleName1 has 1 output port only
  // and moduleName2 has 1 input port only       

    int j;
    ID inPortID = null;
    ID outPortID = null;

    _smreply=requestInit("LMS.backend."+moduleName1,hostName);

    ID senderID = _smreply.getModuleID();
    Vector  tmpPortList1 = _smreply.getPortList();
    int tmpListLenght1 = tmpPortList1.size();
    System.err.println("#### number of ports: "+tmpListLenght1);
    for (j=0;j<tmpListLenght1;j++) {
         outPortID = (ID) tmpPortList1.elementAt(j);
         System.err.println("port # "+j+" id="+outPortID.getInt());
    }

    _smreply=requestInit("LMS.backend."+moduleName2,hostName);

    ID receiverID = _smreply.getModuleID();
    Vector  tmpPortList2 = _smreply.getPortList();
    int tmpListLenght2 = tmpPortList2.size();
    System.err.println("#### number of ports: "+tmpListLenght2);
    for (j=0;j<tmpListLenght2;j++) {
         inPortID = (ID) tmpPortList2.elementAt(j);
         System.err.println("port # "+j+" id="+inPortID.getInt());
    }

     _connect=connect(outPortID, inPortID, senderID, receiverID);

  }  

  public void requestTwoModulesTW(String moduleName1, String moduleName2) {
  
 
    // here I am assuming both modules have 1 output and 1 input ports
    // and they should be connected accross

    int j;
    ID inPortID1 = null;
    ID outPortID1 = null;
    ID inPortID2 = null;
    ID outPortID2 = null;

    _smreply=requestInit("LMS.backend."+moduleName1,hostName);

    ID senderID = _smreply.getModuleID();
    Vector  tmpPortList1 = _smreply.getPortList();
    int tmpListLenght1 = tmpPortList1.size();
    System.err.println("#### number of ports: "+tmpListLenght1);
    outPortID1 = (ID)  tmpPortList1.elementAt(0);
    inPortID1 = (ID)  tmpPortList1.elementAt(1);

    _smreply=requestInit("LMS.backend."+moduleName2,hostName);

    ID receiverID = _smreply.getModuleID();
    Vector  tmpPortList2 = _smreply.getPortList();
    int tmpListLenght2 = tmpPortList2.size();
    System.err.println("#### number of ports: "+tmpListLenght2);
    outPortID2 = (ID)  tmpPortList2.elementAt(0);
    inPortID2 = (ID)  tmpPortList2.elementAt(1);

     _connect=connect(outPortID1, inPortID2, senderID, receiverID);
     _connect=connect(outPortID2, inPortID1, receiverID, senderID);

  }  

}

class connector3 implements Runnable {

  String localhost;
  String host;
  String remotehost;  

  private Thread runner;
  casc2dPanel c;

  connector3(casc2dPanel c, String host){
  this.c=c;
  this.host = host;
  remotehost = null;
  start();
  }

  connector3(casc2dPanel c, String host, String remotehost){
  this.c=c;
  this.host = host;
  this.remotehost = remotehost;
  System.err.println("connector3: connect to a remote host");
  start();
  }

  public void run(){ 
    if(remotehost != null) {
      c.ConnectIt(remotehost,"RGT"+host);  //Remote GeT
    }
    else {
      c.ConnectIt(host,"GET");
    }

    /* must be moved to run method because it won't work for remote modules
       since GET returns before PUT is issued
      try {
        InetAddress local = java.net.InetAddress.getLocalHost();
        localhost = local.getHostName();
        System.out.println("HOST: "+localhost);
       } catch(UnknownHostException e) {System.out.println(e);}
         catch(IOException e) {System.out.println(e);}
 
     c.setValue("DISP"+localhost);
     */
  }
  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }

}

